import { GraphAbstraction } from '../dtos/graph.abstraction.dto';
import { DBAction } from '../entities/db.action';
import { CypherAction } from '../entities/db.cypher.action';
import { IQueryPort } from '../interfaces/query.port';
import { EntityMapper } from '../mappers/graphMapper';
export declare class ActionService {
    protected entityMapper: EntityMapper;
    protected actionPort: IQueryPort;
    constructor();
    findAll(dto: GraphAbstraction, page?: number, size?: number): DBAction;
    findOne(dto: GraphAbstraction): DBAction;
    create(dto: GraphAbstraction, target: string): DBAction;
    update(dto: GraphAbstraction, target: string): DBAction;
    delete(dto: GraphAbstraction, target: string): DBAction;
    runCypher(cypher: string, parameters: any): CypherAction;
    private getTargetEntitieFromString;
}
